//** Modified-Light version of Navigator_tool for TP**// 



#ifndef   	NAVIGATOR_TOOL_H_
# define   	NAVIGATOR_TOOL_H_

#include <stdlib.h>
#include <iostream>
#include <cmath>
#include <string>
#include <errno.h>
#include <stdio.h>


#include <vector>
using namespace std;

#include <V_3D.h>


class Navigator_tool
{						
 public:

  Navigator_tool();
  ~Navigator_tool();

  int set_tr_x(double _tr_x);
  int set_tr_y(double _tr_y);
  int set_tr_z(double _tr_z);
  double get_tr_x();
  double get_tr_y();
  double get_tr_z();
  V_3D get_tr() const;
  int set_tr(const V_3D& v);


  int set_tr2_x(double _tr2_x);
  int set_tr2_y(double _tr2_y);
  int set_tr2_z(double _tr2_z);
  double get_tr2_x();
  double get_tr2_y();
  double get_tr2_z();
  

  int set_tr3_x(double _tr3_x);
  int set_tr3_y(double _tr3_y);
  int set_tr3_z(double _tr3_z);
  double get_tr3_x();
  double get_tr3_y();
  double get_tr3_z();

  int set_tr4_x(double _tr4_x);
  int set_tr4_y(double _tr4_y);
  int set_tr4_z(double _tr4_z);
  double get_tr4_x();
  double get_tr4_y();
  double get_tr4_z();



  int set_theta_1(double _theta_1);
  int set_theta_2(double _theta_2);
  int increase_theta_1(double d_theta);
  int increase_theta_2(double d_theta);
  double get_theta_1();
  double get_theta_2();

  int set_width(double _with);
  int set_height(double _height);
  double get_width();
  double get_height();

  int set_dist_obs(double _dist_obs);
  double get_dist_obs();
  int increase_dist_obs(double factor);
  int increase_dist_obs2(double factor);
  int increase_dist_obs3(double factor);
  int increase_dist_obs4(double factor);

  int set_dist_obs2(double _dist_obs2);
  double get_dist_obs2();
  int set_dist_obs3(double _dist_obs3);
  double get_dist_obs3();
  int set_dist_obs4(double _dist_obs4);
  double get_dist_obs4();


  int set_left_b(int _left_b);
  int set_right_b(int _right_b);
  int get_left_b();
  int get_right_b();

  int set_x_prec(int _x_prec);
  int set_y_prec(int _y_prec);
  int get_x_prec();
  int get_y_prec();

  int set_sel_x(double _sel_x);
  int set_sel_y(double _sel_y);
  int set_sel_z(double _sel_z);
  double get_sel_x();
  double get_sel_y();
  double get_sel_z();

  int increase_sel_x(double d_x);
  int increase_sel_y(double d_y);
  int increase_sel_z(double d_z);


  int go_forward(double d_L);
  int go_backward(double d_L);
  int go_right(double d_L);
  int go_left(double d_L);
  int go_up(double d_L);
  int go_down(double d_L);


  int increase_time();
  int get_counter();
  double get_time();


  int set_screen_size(int X_screen,int Y_screen);
  int get_X_screen() const;
  int get_Y_screen() const;
  double get_screen_ratio() const;

  int set_percent_x(double _percent_x);
  int set_percent_y(double _percent_y);
  double get_percent_x() const;
  double get_percent_y() const;

  int set_current_view(int curent_view);
  int get_current_view() const;


  int get_selection_mode() const;
  int set_selection_mode(int mode);

  int set_selected_joint(int _closest_joint);
  int get_selected_joint() const;

  int get_view_selection_mode() const;
  int set_view_selection_mode(int _view_selection_mode);

  int set_rotation_mode(int _rotation_mode);
  int get_rotation_mode() const;

  int set_N_speed(int _N_speed);
  int get_N_speed() const;

  V_3D get_current_position() const;

  int is_skeleton_shown() const;
  int set_skeleton_shown(int is_shown);

  /// fps
  double get_fps() const;
  int set_current_time(unsigned int _time);
  unsigned int get_current_time() const;
  unsigned int get_old_time() const;
  unsigned int get_delta_time() const;
  double refresh_fps();
  int increase_frame();



 private:

  double tr_x,tr_y,tr_z;
  double theta_1,theta_2;
  double width,height;
  double dist_obs;

  double tr2_x,tr2_y,tr2_z;
  double dist_obs2;
  double tr3_x,tr3_y,tr3_z;
  double dist_obs3;
  double tr4_x,tr4_y,tr4_z;
  double dist_obs4;

  int X_screen,Y_screen;
  double percent_x,percent_y;

  //mouse
  int left_b,right_b;
  int x_prec,y_prec;

  //selection
  double sel_x,sel_y,sel_z;
  
  //time
  int kt;
  double N_speed;
  double start_t,end_t;

  //view
  int current_view;

  int selection_mode;
  int selected_joint;
  int view_selection_mode;
  int rotation_mode;

  int skeleton_shown;

  unsigned int current_time,old_time,frame;
  double current_fps;


};


#endif 	    /* !NAVIGATOR_TOOL_H_ */
